﻿using System;
using System.Text;
using System.Security.Cryptography;

namespace SilverlightS3.Util
{
    /// <summary>
    /// S3 Helper Class
    /// http://timheuer.com/blog/archive/2008/07/05/access-amazon-s3-services-with-silverlight-2.aspx
    /// </summary>
    public class S3Helper
    {
        private const string AWS_ISO_FORMAT = "yyyy-MM-ddTHH:mm:ss.fffZ";
        private const string AWS_ACTION = "AmazonS3";
        
        public static DateTime GetDatestamp()
        {
            DateTime dteCurrentDateTime;
            DateTime dteFriendlyDateTime;
            dteCurrentDateTime = DateTime.Now;
            dteFriendlyDateTime = new DateTime(dteCurrentDateTime.Year,
                dteCurrentDateTime.Month, dteCurrentDateTime.Day,
                dteCurrentDateTime.Hour, dteCurrentDateTime.Minute,
                dteCurrentDateTime.Second, dteCurrentDateTime.Millisecond, 
                DateTimeKind.Local);
            
            return dteFriendlyDateTime;
        }
        
        public static string GetIsoTimestamp(DateTime timeStamp)
        {
            string sISOtimeStamp;
            sISOtimeStamp = timeStamp.ToUniversalTime().ToString(AWS_ISO_FORMAT, 
                                                        System.Globalization.CultureInfo.InvariantCulture);
            
            return sISOtimeStamp;
        }
        
        public static string GenerateSignature(string secret, string S3Operation, DateTime timeStamp)
        {
            Encoding ae = new UTF8Encoding();
            HMACSHA1 signature = new HMACSHA1(ae.GetBytes(secret));
            string rawSignature = AWS_ACTION + S3Operation + GetIsoTimestamp(timeStamp);
            string encodedSignature = Convert.ToBase64String(signature.ComputeHash(ae.GetBytes(rawSignature.ToCharArray())));
            
            return encodedSignature;
        }
    }
}
